uses dos;

type str2=string[2];

const
  dot: array[1..4] of array[0..7] of word= (
    ($0000,$0000,$0000,$1000,$0000,$0000,$0000,$0000),    { 1 pel dot }
    ($0000,$0000,$0000,$1800,$1800,$0000,$0000,$0000),    { 2 pel dot }
    ($0000,$0000,$1800,$3C00,$3C00,$1800,$0000,$0000),    { 4 pel dot }
    ($3C00,$7E00,$FF00,$FF00,$FF00,$FF00,$7E00,$3C00));   { 8 pel dot }
  shademask: array[0..3] of array[0..15] of word= (
    ($FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,   { solid         }
     $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
    ($AAAA,$5555,$AAAA,$5555,$AAAA,$5555,$AAAA,$5555,   { 1 pel chkrbd  }
     $AAAA,$5555,$AAAA,$5555,$AAAA,$5555,$AAAA,$5555),
    ($CCCC,$CCCC,$3333,$3333,$CCCC,$CCCC,$3333,$3333,   { 2 pel chkrbd  }
     $CCCC,$CCCC,$3333,$3333,$CCCC,$CCCC,$3333,$3333),
    ($1111,$AAAA,$4444,$AAAA,$1111,$AAAA,$4444,$AAAA,   { diagonal mesh }
     $1111,$AAAA,$4444,$AAAA,$1111,$AAAA,$4444,$AAAA));
  pattern: array[0..3,0..7] of boolean= (
    (true ,true ,true ,true ,true ,true ,true ,true ),  { solid    }
    (true ,false,false,false,false,false,false,false),  { dots     }
    (true ,true ,true ,true ,false,false,false,false),  { dash     }
    (true ,true ,true ,false,false,true ,false,false)); { dash dot }
  bitmapwidth: word= 80;
  bitmapheight: word= 480;
  bitmapseg: word= $A000;
  bitmapofs: word= 0;

var
  regs: registers;
  dotwidth,dotshade: integer;
  a: char;
  pd: real;

{$L drawdot.obj} procedure drawdot(x,y: integer); external;

procedure drawline(x1,y1,x2,y2,w,s,p,pl,pr: integer);
  { w width, s shade, p pattern, pl pattern length, pr pattern reset? }
  var
    xr,yr,dxr,dyr,dpd: real; { pd is global }
    x,y,dx,dy: integer;
  begin
    dotwidth:=w; { drawdot reads these global variables }
    dotshade:=s;
    if abs(x2-x1)>=abs(y2-y1) then begin
      { dx, dyr := change in x, y for each x step }
        if x1<=x2 then dx:=1 else dx:=-1;
        if x1<>x2 then dyr:=(y2-y1)/abs(x2-x1) else dyr:=0;
      yr:=y1; x:=x1-dx;
      if p=0 then begin { no dash pattern }
        drawdot(x1,y1);
        repeat
          inc(x,dx);
          if odd(x) or (w<=2) then drawdot(x,round(yr));
          yr:=yr+dyr;
        until x=x2;
        drawdot(x2,y2);
      end
      else begin { draw line with a dash pattern }
        dpd:=sqrt(1+sqr(dyr))/pl*8; { dpd := change in pd for each x step }
        if pr=1 then pd:=0;
        repeat
          inc(x,dx);
          if pattern[p,trunc(pd) and 7] then drawdot(x,round(yr));
          yr:=yr+dyr;
          pd:=pd+dpd;
        until x=x2;
      end;
    end
    else begin
      { dxr, dy := change in x, y for each y step }
        dxr:=(x2-x1)/abs(y2-y1);
        if y1<y2 then dy:=1 else dy:=-1;
      xr:=x1; y:=y1-dy;
      if p=0 then begin { no dash pattern }
        drawdot(x1,y1);
        repeat
          inc(y,dy);
          if odd(y) or (w<=2) then drawdot(round(xr),y);
          xr:=xr+dxr;
        until y=y2;
        drawdot(x2,y2);
      end
      else begin { draw line with dash pattern }
        dpd:=sqrt(sqr(dxr)+1)/pl*8; { dpd := change in pd for each y step }
        if pr=1 then pd:=0;
        repeat
          inc(y,dy);
          if pattern[p,trunc(pd) and 7] then drawdot(round(xr),y);
          xr:=xr+dxr;
          pd:=pd+dpd;
        until y=y2;
      end;
    end;
  end;

procedure drawlinecolor(x1,y1,x2,y2,w,s,p,pl,pr: integer; c: str2);
  { w width, s shade, p pattern, pl pattern length, pr pattern reset? }
  { c color(s)                                                        }
  var initialpd: real;
  begin
    initialpd:=pd; { (each redraw must start at same dash pattern point) }
    if upcase(c[1]) in ['B','C','M','W'] then begin { blue plane }
      port[$3C4]:=2; port[$3C5]:=1; portw[$3CE]:=5; portw[$3CE]:=$004;
      pd:=initialpd;
      drawline(x1,y1,x2,y2,w,s,p,pl,pr);
    end;
    if upcase(c[1]) in ['G','C','Y','W'] then begin { green plane }
      port[$3C4]:=2; port[$3C5]:=2; portw[$3CE]:=5; portw[$3CE]:=$104;
      pd:=initialpd;
      drawline(x1,y1,x2,y2,w,s,p,pl,pr);
    end;
    if upcase(c[1]) in ['R','M','Y','W'] then begin { red plane }
      port[$3C4]:=2; port[$3C5]:=4; portw[$3CE]:=5; portw[$3CE]:=$204;
      pd:=initialpd;
      drawline(x1,y1,x2,y2,w,s,p,pl,pr);
    end;
    if length(c)=2 then begin
      pd:=initialpd;
      drawlinecolor(x1,y1,x2,y2,w,0,p,pl,pr,c[2]);
    end;
  end;

begin

  { set up screen }
    regs.ax:=$12; intr($10,regs);

  { line dash patterns and widths }
    drawlinecolor(  0,0,  0,200,1,0,0,20,1,'w');
    drawlinecolor( 10,0, 10,200,1,0,1,20,1,'w');
    drawlinecolor( 20,0, 20,200,1,0,2,20,1,'w');
    drawlinecolor( 30,0, 30,200,1,0,3,20,1,'w');

    drawlinecolor( 50,0, 50,200,2,0,0,20,1,'g');
    drawlinecolor( 60,0, 60,200,2,0,1,20,1,'g');
    drawlinecolor( 70,0, 70,200,2,0,2,20,1,'g');
    drawlinecolor( 80,0, 80,200,2,0,3,20,1,'g');

    drawlinecolor(100,0,100,200,3,0,0,40,1,'r');
    drawlinecolor(110,0,110,200,3,0,1,40,1,'r');
    drawlinecolor(120,0,120,200,3,0,2,40,1,'r');
    drawlinecolor(130,0,130,200,3,0,3,40,1,'r');

    drawlinecolor(150,0,150,200,4,0,0,40,1,'m');
    drawlinecolor(160,0,160,200,4,0,1,40,1,'m');
    drawlinecolor(170,0,170,200,4,0,2,40,1,'m');
    drawlinecolor(180,0,180,200,4,0,3,40,1,'m');

  { shading }
    drawlinecolor(200,0,200,200,3,1,0,40,1,'c');
    drawlinecolor(210,0,210,200,3,1,1,40,1,'c');
    drawlinecolor(220,0,220,200,3,1,2,40,1,'c');
    drawlinecolor(230,0,230,200,3,1,3,40,1,'c');

    drawlinecolor(250,0,250,200,4,2,0,40,1,'c');
    drawlinecolor(260,0,260,200,4,2,1,40,1,'c');
    drawlinecolor(270,0,270,200,4,2,2,40,1,'c');
    drawlinecolor(280,0,280,200,4,2,3,40,1,'c');

    drawlinecolor(300,0,300,200,3,3,0,40,1,'w');
    drawlinecolor(310,0,310,200,3,3,1,40,1,'w');
    drawlinecolor(320,0,320,200,3,3,2,40,1,'w');
    drawlinecolor(330,0,330,200,3,3,3,40,1,'w');

    drawlinecolor(350,0,350,200,4,3,0,40,1,'w');
    drawlinecolor(360,0,360,200,4,3,1,40,1,'w');
    drawlinecolor(370,0,370,200,4,3,2,40,1,'w');
    drawlinecolor(380,0,380,200,4,3,3,40,1,'w');

  { pure colors }
    drawlinecolor(  0,250,  0,450,4,0,0,0,1,'r');
    drawlinecolor( 10,250, 10,450,4,0,0,0,1,'y');
    drawlinecolor( 20,250, 20,450,4,0,0,0,1,'g');
    drawlinecolor( 30,250, 30,450,4,0,0,0,1,'c');
    drawlinecolor( 40,250, 40,450,4,0,0,0,1,'b');
    drawlinecolor( 50,250, 50,450,4,0,0,0,1,'m');
    drawlinecolor( 60,250, 60,450,4,0,0,0,1,'w');

  { light and dark colors }
    drawlinecolor(100,250,100,450,4,1,0,0,1,'cr');
    drawlinecolor(110,250,110,450,4,0,0,0,1,'r');
    drawlinecolor(120,250,120,450,4,1,0,0,1,'r');
    drawlinecolor(130,250,130,450,4,1,0,0,1,'by');
    drawlinecolor(140,250,140,450,4,0,0,0,1,'y');
    drawlinecolor(150,250,150,450,4,1,0,0,1,'y');
    drawlinecolor(160,250,160,450,4,1,0,0,1,'mg');
    drawlinecolor(170,250,170,450,4,0,0,0,1,'g');
    drawlinecolor(180,250,180,450,4,1,0,0,1,'g');
    drawlinecolor(190,250,190,450,4,1,0,0,1,'rc');
    drawlinecolor(200,250,200,450,4,0,0,0,1,'c');
    drawlinecolor(210,250,210,450,4,1,0,0,1,'c');
    drawlinecolor(220,250,220,450,4,1,0,0,1,'yb');
    drawlinecolor(230,250,230,450,4,0,0,0,1,'b');
    drawlinecolor(240,250,240,450,4,1,0,0,1,'b');
    drawlinecolor(250,250,250,450,4,1,0,0,1,'gm');
    drawlinecolor(260,250,260,450,4,0,0,0,1,'m');
    drawlinecolor(270,250,270,450,4,1,0,0,1,'m');

  { spectrum with mixed colors }
    drawlinecolor(310,250,310,450,4,0,0,0,1,'r');
    drawlinecolor(320,250,320,450,4,1,0,0,1,'gr');
    drawlinecolor(330,250,330,450,4,0,0,0,1,'y');
    drawlinecolor(340,250,340,450,4,1,0,0,1,'rg');
    drawlinecolor(350,250,350,450,4,0,0,0,1,'g');
    drawlinecolor(360,250,360,450,4,1,0,0,1,'bg');
    drawlinecolor(370,250,370,450,4,0,0,0,1,'c');
    drawlinecolor(380,250,380,450,4,1,0,0,1,'gb');
    drawlinecolor(390,250,390,450,4,0,0,0,1,'b');
    drawlinecolor(400,250,400,450,4,1,0,0,1,'rb');
    drawlinecolor(410,250,410,450,4,0,0,0,1,'m');
    drawlinecolor(420,250,420,450,4,1,0,0,1,'br');

  { lines }
    drawlinecolor(450,  0,450,450,3,2,0,0,1,'y');
    drawlinecolor(600,  0,600,450,3,2,0,0,1,'y');
    drawlinecolor(450,  0,600,  0,3,2,0,0,1,'y');
    drawlinecolor(450,450,600,450,3,2,0,0,1,'y');

    drawlinecolor(450,  0,600, 75,3,0,3,40,1,'r');
    drawlinecolor(600, 75,450,150,3,0,3,40,0,'r');
    drawlinecolor(450,150,600,300,3,0,3,40,0,'r');
    drawlinecolor(600,300,450,450,3,0,3,40,0,'r');

    drawlinecolor(450,  0,600,150,3,0,0,0,1,'m');
    drawlinecolor(450,300,600,375,3,0,0,0,1,'m');
    drawlinecolor(450,450,600,375,3,0,0,0,1,'m');

    drawlinecolor(600,  0,450, 75,3,0,3,40,1,'g');
    drawlinecolor(450, 75,600,150,3,0,3,40,0,'g');
    drawlinecolor(600,150,450,300,3,0,3,40,0,'g');
    drawlinecolor(450,300,600,450,3,0,3,40,0,'g');

    drawlinecolor(450,150,600,  0,3,0,0,0,0,'c');
    drawlinecolor(450,375,600,300,3,0,0,0,0,'c');
    drawlinecolor(450,375,600,450,3,0,0,0,0,'c');

  { pause for any key, go to text mode }
    regs.ax:=0; intr($16,regs);
    regs.ax:=3; intr($10,regs);

end.